module Nokogiri
  module XML
    class Document < Nokogiri::XML::Node
      def to_hash
        children_to_hash(children)
      end

      private
      def children_to_hash(children)
        hash = {}
        children.each do |child|
          if child.children.any?
            if hash.key?(child.name.to_sym)
              hash[child.name.to_sym] = [
                hash[child.name.to_sym],
                children_to_hash(child.children)
              ]
            else
              hash[child.name.to_sym] = children_to_hash(child.children)
            end
          else
            hash = child.content.to_s
          end
        end
        hash
      end
    end
  end
end
